#-----------------------------------------------------------------------------
# Script to set up the environment for building Karma at the ATNF.
# Refer to the instructions in ./INSTALL.
#
# 2011/05/03 Mark Calabretta, ATNF
#-----------------------------------------------------------------------------
# Set things to point to here.
  setenv KARMAROOT `pwd`

  if ("$LOGIN_ARCH" == darwin) then
    if ("$MACHTYPE" == x86_64) then
      setenv MACHINE x86_64
    else
      setenv MACHINE i386
    endif

    setenv MACHINE_OS ${MACHINE}_Darwin
    setenv MYOS darwin

  else if ("$LOGIN_ARCH" == darwin_ppc) then
    setenv MACHINE_OS powerpc_Darwin
    setenv MYOS darwin

  else if ("$LOGIN_ARCH" == linux) then
    if ("`uname -m`" == x86_64) then
      setenv MACHINE_OS amd64_Linux
      setenv MYOS linux64
    else
      setenv MACHINE_OS i386_Linux
      setenv MYOS linux
    endif

  else if ("$LOGIN_ARCH" == linux64) then
    setenv MACHINE_OS amd64_Linux
    setenv MYOS linux64

  else if ("$LOGIN_ARCH" == sun4sol) then
    setenv MACHINE_OS sparc_Solaris
    setenv MYOS sun4sol
  endif

  unsetenv MACHINE OS

  setenv KARMABASE "$KARMAROOT/$MACHINE_OS"

  mkdir -p "$KARMABASE"
  [ -d "$KARMABASE"/include ] || ln -s ../include "$KARMABASE"/include

  source "$KARMAROOT"/.login
  source "$KARMAROOT"/.cshrc
