/*----------------------------------------------------------*/
/*  Communications sample program:  query client            */
/*----------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/resource.h>
#include <karma_conn.h>
#include <karma_dm.h>
#include <karma_ch.h>
#include <karma_r.h>


#define PORT_NUMBER 10000


void main (int argc, char **argv)
{
    Connection connection;
    Channel ch;
    char dummy;
    unsigned int num_iter, count;
    double d_time, reltime;
    static struct timezone tz = {0, 0};
    struct timeval curr_time;
    struct timeval old_time;

    /*  Initialise communications package  */
    dm_native_setup ();
    conn_initialise ( ( void (*) () ) NULL );
    /*  Register server protocols  */
    conn_register_client_protocol ("query_data", 0, 0,
                                   ( flag (*) () ) NULL, ( flag (*) () ) NULL,
				   ( flag (*) () ) NULL, ( void (*) () ) NULL);
    gettimeofday (&old_time, &tz);
    /*  Connect to server  */
    if ( !conn_attempt_connection (argv[1], PORT_NUMBER, "query_data") )
    {
        fprintf (stderr, "Could not connect to server\n");
        exit (1);
    }
    connection = conn_get_client_connection ("query_data", 0);
    ch = conn_get_channel (connection);
    num_iter = atoi (argv[2]);
    for (count = 0; count < num_iter; ++count)
    {
	ch_write (ch, &dummy, 1);
	ch_flush (ch);
	ch_read (ch, &dummy, 1);
	gettimeofday (&curr_time, &tz);
	d_time = curr_time.tv_sec;
	d_time += (double) curr_time.tv_usec * 1e-6;
	reltime = (double) (curr_time.tv_sec - old_time.tv_sec) * 1e3;
	reltime += (double) (curr_time.tv_usec - old_time.tv_usec) * 1e-3;
	fprintf (stderr, "%f s\t%.2f ms\n", d_time, reltime);
    }
}   /*  End Function main  */
