/*  globals.c

    Globals file for  kpvslice  (X11 Position-Velocity slice tool for Karma).

    Copyright (C) 1996-2001  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*
    This Karma module will enable interactive selection of a Position-Velocity
    slice through a data cube.
    This module runs on an X11 server.


    Written by      Richard Gooch   13-AUG-1996

    Last updated by Richard Gooch   19-MAR-2001


*/

#include "kpvslice.h"

/*  The list of slice displays (each may have a loaded cube)  */
SliceDisplay *first_slice_display = NULL;
SliceDisplay *last_slice_display = NULL;

/*  Loaded image information  */
iarray image_arr = NULL; 
ViewableImage image_vimage = NULL;

/*  Main canvas information  */
KWorldCanvas main_canvas = NULL;
unsigned int image_mode = IMAGE_MODE_LOADED;

/*  Moment maps  */
iarray mom0_arr = NULL;
iarray mom1_arr = NULL;
ViewableImage mom0_vimage = NULL;
ViewableImage mom1_vimage = NULL;

/*  Slice (aux) canvas information  */
char *trace_internal_colour = "red";
char *trace_external_colour = "green";


char title_name[STRING_LENGTH] = "Unknown";
