/*  pvget.h

    Include file for  pvget  (Position-Velocity slice extraction for Karma).

    Copyright (C) 2002  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*
    This file contains declarations for the pvget.c code.


    Written by      Richard Gooch   5-JAN-2002: Moved from kpvslice.h

    Last updated by Richard Gooch   5-JAN-2002


*/
#include <karma.h>
#include <karma_iarray_def.h>


/*  File: pvget.c  */
EXTERN_FUNCTION (unsigned int get_slice,
		 (iarray cube, int x1, int y1, int x2, int y2,
		  double **x_locus, double **y_locus) );
EXTERN_FUNCTION (iarray pvslice,
		 (iarray cube, unsigned int num_points, double *x_locus,
		  double *y_locus) );
