	.file	"project_line_i860.c"
	.text
	.align	8
_L00TEXT: 
	.text;	.align	8
//--------------| project_line_loop |-----------------------: frame was referenced.
//Stack allocation: Autos:0 Regsave:40

_project_line_loop::

// Define aliases for registers

// NOTE: for some reason, the C compiler will not pass floating point register
// parameters past f27, any more float parameters will come through the stack.

// Register Parameters
#define line			r16
#define length			r17
#define inp_stride		r18
#define image			r19
#define yoffsets		r20
#define lower_threshold		r21
#define one_on_sq1		f16
#define one_on_sq2		f17
#define one_on_sq3		f18
#define prep_arrays		r22
#define distance_2d_prep	f19
#define coord_h_prep		f20
#define coord_v_prep		f21
#define scale_h			f22
#define scale_v			f23
#define sq_distance_3d_prep	f24
#define minimum_h		f25
#define maximum_h		f26
#define minimum_v		f27

// Stack Parameters
#define maximum_v		f28
#define toobig			f29

// Temporaries
#define inp_value		r4
#define distance_2d		f5	// prep_arrays[0]
#define sq_distance_3d		f4	// prep_arrays[1]
#define coord_h			f7	// prep_arrays[2]
#define coord_v			f6	// prep_arrays[3]
#define image_ptr		r5

#define temp1			r6
#define ftemp1			f8
#define ftemp2			f9
#define ftemp3			f10
#define ftemp4			f11
#define ftemp5			f12
#define ftemp6			f13
#define ftemp7			f14
#define ftemp8			f15

// Get stack parameters
	fld.l		0(sp), maximum_v
	fld.l		4(sp), toobig
// Save some registers
	addu		-64, sp, sp
	fst.q		f4, 0(sp)
	fst.q		f8, 16(sp)
	fst.q		f12, 32(sp)
	st.l		r4, 48(sp)
	st.l		r5, 52(sp)
	st.l		r6, 56(sp)
	nop

// Start dual instruction mode
// Clean up pipe			// Test if there are any points to do
	d.fmul.ss	f0, f0, f0	;	adds	-1, length, length
	d.fadd.ss	f0, f0, f0	;	nop
// Load KR with 0
	d.mr2pt.ss	f0, f0, f0	;	bc	.finished
					//Prepare prep_arrays for autoinc
	d.mm12mpm.ss	f0, f0, f0	;	addu	-16, prep_arrays, prep_arrays

.loop:
					// Get value
#ifndef TEST_CODE
	d.ra1p2.ss	f0, f0, f0	;	ld.b	0(line), inp_value
#else
	d.ra1p2.ss	f0, f0, f0	;	adds	r0, r0, inp_value
#endif
					// Increment pointer (line)
	d.ra1p2.ss	f0, f0, f0	;	addu	inp_stride, line, line
					// Compare value with minimum
	d.ra1p2.ss	f0, f0, f0	;	subs	lower_threshold, inp_value, r0
	d.ra1p2.ss	f0, f0, f0	;	bnc.t	.next_entry
	d.ra1p2.ss	f0, f0, f0	;	addu 16, prep_arrays, prep_arrays
// filling
	d.ra1p2.ss	f0, f0, f0	;	nop
	d.ra1p2.ss	f0, f0, f0	;	nop
	d.ra1p2.ss	f0, f0, f0	;	nop
// end filling
					// Get *prep_arrays++
#ifndef TEST_CODE
	d.r2p1.ss	f0, f0, f0	;	fld.q	16(prep_arrays)++, sq_distance_3d
#else
	d.r2p1.ss	f0, f0, f0	;	fld.q	16(prep_arrays), sq_distance_3d
#endif
// Compute distance_2d = curr_distance_2d + distance_2d_prep
	d.fadd.ss	distance_2d, distance_2d_prep, distance_2d ; nop
// Test: distance_2d <= 0.0
	d.pfle.ss	distance_2d, f0, f0	;	nop
					// Branch on test (distance_2d <= 0.0)
	d.mm12mpm.ss	f0, f0, f0	;	bnc.t	.next_entry
	d.mm12mpm.ss	f0, f0, f0	;	nop
// Start distance_2d * one_on_sq3
	d.mm12mpm.ss	distance_2d, one_on_sq3, f0;	nop
// Start curr_coord_h + coord_h_prep
	d.ra1p2.ss	coord_h, coord_h_prep, f0	;	nop
// Start curr_coord_v + coord_v_prep
	d.ra1p2.ss	coord_v, coord_v_prep, f0	;	nop
// Start curr_sq_point_v0 + sq_distance_3d_prep and Get distance_2d * one_on_sq3
	d.mrm1p2.ss	sq_distance_3d, sq_distance_3d_prep, distance_2d	;nop
// Get curr_coord_h + coord_h_prep
	d.ra1p2.ss	f0, f0, coord_h			;	nop
// Get curr_coord_v + coord_v_prep
	d.ra1p2.ss	f0, f0, coord_v			;	nop
// Get sq_distance_3d = curr_sq_point_v0 + sq_distance_3d_prep
	d.ra1p2.ss	f0, f0, sq_distance_3d		;	nop
// Compute distance_2d = 1.0 / (distance_2d * one_on_sq3)
	d.frcp.ss	distance_2d, distance_2d	;	nop
// Start one_on_sq1 * distance_2d
	d.mm12mpm.ss	one_on_sq1, distance_2d, f0	;	nop
// Start one_on_sq2 * distance_2d
	d.mm12mpm.ss	one_on_sq2, distance_2d, f0	;	nop
	d.mm12mpm.ss	f0, f0, f0			;	nop
// Get one_on_sq1 * distance_2d
	d.mm12mpm.ss	f0, f0, ftemp1			;	nop
// Start (curr_coord_h + coord_h_prep) * one_on_sq1 * distance_2d
// Get one_on_sq2 * distance_2d
	d.mm12mpm.ss	ftemp1, coord_h, ftemp2		;	nop
// Start (curr_coord_v + coord_v_prep) * one_on_sq2 * distance_2d
	d.mm12mpm.ss	ftemp2, coord_v, f0		;	nop
// Initiate exit from dual instruction mode
	mm12mpm.ss	f0, f0, f0			;	nop
// Get coord_h = (curr_coord_h + coord_h_prep) * one_on_sq1 * distance_2d
	mm12mpm.ss	f0, f0, coord_h			;	nop
// Get coord_v = (curr_coord_v + coord_v_prep) * one_on_sq2 * distance_2d
	mm12mpm.ss	f0, f0, coord_v			;	nop
// ----------------------------------------------------------------------------
// Test (coord_h <= minimum_h)
	pfle.ss		coord_h, minimum_h, f0
// Branch (coord_h <= minimum_h)
	bnc		.next_entry
// Test (coord_h > maximum_h)
	pfgt.ss		coord_h, maximum_h, f0
// Branch (coord_h > maximum_h)
	bc		.next_entry
// Test (coord_v <= minimum_v)
	pfle.ss		coord_v, minimum_v, f0
// Branch (coord_v <= minimum_v)
	bnc		.next_entry
// Test (coord_v > maximum_v)
	pfgt.ss		coord_v, maximum_v, f0
// Branch (coord_v > maximum_v)
	bc		.next_entry
// Initiate dual instruction mode
// Start coord_v - minimum_v			// Start (float) inp_value
	d.ra1s2.ss	coord_v, minimum_v, f0		;orh	32768, r0, temp1
// ----------------------------------------------------------------------------
// Start coord_h - minimum_h
	d.ra1s2.ss	coord_h, minimum_h, f0		;	ixfr	temp1, ftemp5
	d.ra1s2.ss	f0, f0, f0			;	orh	17200, r0, temp1
// Get coord_v - minimum_v
	d.ra1s2.ss	f0, f0, coord_v			;	ixfr	temp1, ftemp6
// Start (coord_v - minimum_v) * scale_v
// Get coord_h - minimum_h
	d.m12asm.ss	coord_v, scale_v, coord_h	;	xorh	32768, inp_value, temp1
// Start (coord_h - minimum_h) * scale_h
	d.mm12msm.ss	coord_h, scale_h, f0		;	ixfr	temp1, ftemp7
	d.mm12msm.ss	f0, f0, f0			;	nop
// Get (coord_v - minimum_v) * scale_v
	d.mm12msm.ss	f0, f0, coord_v			;	nop
// Get (coord_h - minimum_h) * scale_h
	d.mrm1p2.ss	f0, f0, coord_h			;	nop
// Compute (int) (0.5 + (coord_v - minimum_v) * scale_v)
	d.fix.sd	coord_v, ftemp1			;	nop
// Transfer (int) (0.5 + (coord_v - minimum_v) * scale_v) to core unit
	d.fxfr		ftemp1, temp1			;	nop
// Compute (int) (0.5 + (coord_h - minimum_h) * scale_h)	// Compute image_ptr
	d.fix.sd	coord_h, ftemp3			;	shl	2, temp1, temp1
// Transfer (int) (0.5 + (coord_h - minimum_h) * scale_h)
#define temp2 r27
	d.fxfr		ftemp3, temp2			;	nop
	d.mm12mpm.ss	f0, f0, f0			;	ld.l	yoffsets(temp1), image_ptr
// ---------------------------------------------------------------------------
// Continue computing (float) inp_value
	d.fmov.ss	ftemp6, ftemp8			;	addu	image_ptr, temp2, image_ptr
	d.fsub.dd	ftemp7, ftemp5, ftemp7		;	shl	2, image_ptr, image_ptr
							// Get *image_ptr
	d.fmov.ds	ftemp7, ftemp1			;	fld.l	image_ptr(image), ftemp2
// ---------------------------------------------------------------------------
// Compute 1.0 / sq_distance_3d
	d.frcp.ss	sq_distance_3d, sq_distance_3d	;	nop
// Compute (float) inp_value / sq_distance_3d
	d.fmul.ss	ftemp1, sq_distance_3d, sq_distance_3d	;	nop
// Test (*image_ptr == TOOBIG)
	d.pfeq.ss	ftemp2, toobig, f0		;	nop
				// Branch (*image_ptr == TOOBIG)
	d.mm12mpm.ss	f0, f0, f0			; bc	.set_point
// Compute *image_ptr + (float) inp_value / sq_distance_3d
	d.fadd.ss	ftemp2, sq_distance_3d, sq_distance_3d	;	nop
.set_point:
							// Put *image_ptr
	d.mm12mpm.ss	f0, f0, f0			;	fst.l	sq_distance_3d, image_ptr(image)


.next_entry:
							// --length
	d.mm12mpm.ss	f0, f0, f0			;	adds -1, length, length
	d.mm12mpm.ss	f0, f0, f0			;	bnc.t	.loop
	d.mm12mpm.ss	f0, f0,	f0			;	nop

.finished:
	d.mm12mpm.ss	f0, f0,	f0			;	nop
	mm12mpm.ss	f0, f0,	f0			;	nop
	mm12mpm.ss	f0, f0, f0			;	nop
// Restore some registers
.done:
	fld.q		0(sp), f4
	fld.q		16(sp), f8
	fld.q		32(sp), f12
	ld.l		48(sp), r4
	ld.l		52(sp), r5
	ld.l		56(sp), r6
	bri		r1
	addu		64, sp, sp
// End ------------------------------------------------------------------------
	.oVhc2.3  =: 0
