/*  globals_render.c

    Render globals file for  xray  (Karma volume rendering tool).

    Copyright (C) 1996-1999  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*  This file contains all rendering global variables.


    Written by      Richard Gooch   14-DEC-1996

    Last updated by Richard Gooch   5-JAN-1999


*/

#include <stdio.h>
#include <karma.h>
#include "render.h"


/*  Public data  */

/*  Shared information for continuous and three colour Hot Gas shader  */
float fullcolour_hg_reds[FULLCOLOUR_HOT_GAS_CMAP_SIZE];
float fullcolour_hg_greens[FULLCOLOUR_HOT_GAS_CMAP_SIZE];
float fullcolour_hg_blues[FULLCOLOUR_HOT_GAS_CMAP_SIZE];
float fullcolour_hg_opacities[FULLCOLOUR_HOT_GAS_CMAP_SIZE];

/*  Mono Hot Gas information  */
float mono_hg_intensities[MONO_HOT_GAS_CMAP_SIZE];
float mono_hg_opacities[MONO_HOT_GAS_CMAP_SIZE];

/*  Substance information  */
int num_substances = 8;
unsigned int bad_substance_count = 0;
char voxel_to_substance_indices[256];
substance substances[MAX_SUBSTANCES];
flag substances_all_transparent = TRUE;

/*  Offset control display  */
int voxel_sum_position = 0;

/*  Front voxel information  */
int voxel_threshold = -127;

/*  Cube info  */
int skip_factor = 1;

/*  Verbosity flags  */
flag verbose = FALSE;
