#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <karma.h>


void skip_until ();

int main (int argc, char *argv[])
{
    FILE *fp_in;
    FILE *fp_out;
    char txt[STRING_LENGTH + 1];
    char return_type[STRING_LENGTH + 1];
    char *ptr;
    extern int errno;

    if (argc == 2)
    {
	if ( ( fp_in = fopen (argv[1], "r") ) == NULL )
	{
	    (void) fprintf (stderr, "Error opening file: \"%s\"\t%s\n",
			    argv[1], ERRSTRING);
	    exit (1);
	}
    }
    else
    {
	fp_in = stdin;
    }
    fp_out = stdout;
    /*  Process lines  */
    /*  Start looking for functions  */
    while (1 == 1)
    {
	skip_until (fp_in, "/*PUBLIC_FUNCTION*/", txt, STRING_LENGTH);
	if (txt[0] == '\0')
	{
	    exit (0);
	}
	/*  Another function to process  */
	if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	{
	    exit (0);
	}
	(void) fputs ("\n", fp_out);
	/*  Process function definition  */
	for (ptr = txt; isspace (*ptr); ++ptr);
	if (strncmp (ptr, "static ", 7) == 0)
	{
	    (void) fprintf (stderr, "Public function declared static\n");
	    (void) fprintf (stderr, "Bad line: \"%s\"\n", txt);
	    exit (1);
	}
	(void) strcpy (return_type, ptr);
	/*  Find and remove '('  */
	if ( ( ptr = strchr (return_type, '(') ) == NULL )
	{
	    (void) fprintf (stderr, "No opening parenthesis\n");
	    (void) fprintf (stderr, "Bad line: \"%s\"\n", txt);
	    exit (1);
	}
	*ptr = '\0';
	/*  Remove trailing whitespace  */
	--ptr;
	while ( isspace (*ptr) )
	{
	    *ptr = '\0';
	    --ptr;
	}
	/*  Remove function name  */
	for (--ptr; ptr >= return_type; --ptr)
	{
	    if ( isspace (*ptr) )
	    {
		*ptr = '\0';
		ptr = return_type - 1;
		continue;
	    }
	    if (*ptr == '*')
	    {
		ptr = return_type - 1;
		continue;
	    }
	    *ptr = '\0';
	}
	if (return_type[0] == '\0') (void) strcpy (return_type, "int");
	while (txt[0] != '{')
	{
	    (void) fputs (txt, fp_out);
	    if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	    {
		exit (0);
	    }
	}
	(void) fputs ("{\n", fp_out);
	if (strcmp (return_type, "void") != 0)
	{
	    (void) fprintf (fp_out, "    return ( (%s) 0 );\n", return_type);
	}
	(void) fputs ("}\n", fp_out);
    }
    return (0);
}   /*  End Function main  */

void skip_until (fp, string, out_string, length)
FILE *fp;
char *string;
char *out_string;
unsigned int length;
{
    while (fgets (out_string, length, fp) != NULL)
    {
	if (strncmp ( out_string, string, strlen (string) ) == 0)
	{
	    return;
	}
    }
    out_string[0] = '\0';
}
